
/*---------------------------------------------------------------------------------------

	INITGestalt.h : a first pass at a header based on the INITGestalt proposal
					by Jeremy Roussak (jeremyr@dcs.qmw.ac.uk) and
					Ren G.A. Ros (rgaros@bio.vu.nl).

	Change History :

	10/22/94 DdE	Created.
	10/22/94 DdE	Added my suggested changes.
	10/24/94 JBR	Slight changes to INITGestaltRec layout
	01/13/95 DdE	Update to INITGestalt 1.0a6 specs.
	01/15/95 DdE	Update to INITGestalt 1.0a7 specs.
	01/19/95 DdE	Updated for changes in the 1.0a8 specs.
	01/22/95 RR		Updated for changes in the 1.0a9 specs.
	01/31/95 DdE	Update for 1.0b1 specs.
	03/14/95 DdE	Updated for 1.0 release. Changed kIGRecCurrentVersion, removed all
					references to IGControl, updated field names and added
					igPlatformType, added 68K alignment pragmas.
	04/01/95 DdE	Changed custom types to types defined in the new Universal Headers.
					Removed kIGPPCNative flag definition (obsolete).

---------------------------------------------------------------------------------------*/

#ifndef	__INITGestalt__
#define	__INITGestalt__

#ifndef __GESTALTEQU__
#include <GestaltEqu.h>
#endif

enum InitGestaltDefines {
	kIGRecType					= 'JRRR',
	kIGRecCurrentVersion		= 0x01008000,	// 1.0 release

	// bit constants for the igStdAttr field
	kIGEnabled					= 0,
	kIGDebugVersion,
	kIGDebugEnabled,
	kIGAcceptsAEvents
	};


/*________________________________ INIT Gestalt Record ________________________________*/

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

typedef struct {
	OSType					recType;		// must always be kGestaltRecordType
	NumVersion				recVersion;		// the version of the record format
	NumVersion				igVersion;		// version of installed software
	UInt32					igStdAttr;		// attribute bits defined by standard
	UInt32					reserved1;		// reserved
	UInt32					igCustomAttr;	// attribute bits defined by software
	ProcessSerialNumber		igProcess;		// PSN of installer
	ISAType					igPlatformType;	// platform type
	UInt8					reserved2;		// reserved
	UInt16					reserved3;		// reserved
	UInt32					igRefCon;		// for private use
	} INITGestaltRec, *INITGestaltRecPtr, **INITGestaltRecHdl;

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif


#endif	/* __INITGestalt__ */
