//==============================================================================
// KEYQUENCER GESTALT UTILITIES - VERSION 1.2.2 - DECEMBER 1995
// By Alessandro Levi Montalcini <alm@torino.alpcom.it>
// 1994-96 Binary Software, Inc. <binarysoft@eworld.com>
// This text looks best in monaco 9 font, 4 spaces per tab, no wrapping
//==============================================================================

#include "KQGestalt.h"

//==============================================================================
// Returns a pointer to the KeyQuencer glue record (defined in Extension.h)
// or NIL if KeyQuencer is not running. Both the old shareware versions and
// the new commercial versions are supported - you should check the glueRecVers
// field of the glue record itself to see which routines are available.

GluePtr GetKeyQuencerGlue(void)
{
	GluePtr	glue;
	long	response;
	
	if(Gestalt(kKQ20GestaltSelector, &response)==noErr
	&& ((INITGestaltRecPtr)response)->recType==kIGRecType)
		glue = GET_KQ20_GLUE(response);
	else if(Gestalt(kKQ12GestaltSelector, &response)==noErr
	&& ((KQGestaltPtr)response)->kqSignature==kKQ12GestaltSelector)
		glue = GET_KQ12_GLUE(response);
	else glue = 0L;
	return glue;
}

//==============================================================================
