// =============================================================================
// KEYQUENCER GESTALT HEADER - VERSION 1.2.2 - DECEMBER 1995
// By Alessandro Levi Montalcini <alm@torino.alpcom.it>
// 1994-96 Binary Software, Inc. <binarysoft@eworld.com>
// This text looks best in monaco 9 font, 4 spaces per tab, no wrapping
//==============================================================================
#pragma once
#ifndef _H_kqgestalt
#define _H_kqgestalt

#include "Extension.h"
#include "INITGestalt.h"
//==============================================================================
#if GENERATINGPOWERPC
#pragma options align=mac68k
#endif
//==============================================================================
// KEYQUENCER GESTALT RECORD (COMMERCIAL VERSIONS):
// Starting from KQ 2.0b2, Gestalt returns a pointer to an INITGestalt structure
// that contains a GluePtr in the igRefCon field.

#define kKQ20GestaltSelector	'KQen'		// returns a pointer to an INITGestalt record

#define GET_KQ20_GLUE(gestaltResponse) ((GluePtr)((INITGestaltRecPtr)(gestaltResponse))->igRefCon)

// =============================================================================
// KEYQUENCER GESTALT RECORD (SHAREWARE VERSIONS):
// In all previous shareware and beta versions (1.0 to 1.2.2, 1.3b1 to 2.0b1),
// Gestalt returned a pointer to the KQGestaltRec data structure.

#define kKQ12GestaltSelector	'KQue'		// returns a pointer to the structure below
#define kKQ12GestaltVersion		1			// values from 1 to 4 are always OK

typedef struct {
	long		kqSignature;				// must be kKQ12GestaltSelector
	short		kqGestaltVersion;			// must be >= kKQ12GestaltVersion
	short		kqReservedField;			// reserved
	GluePtr		*glueRecPtr;				// pointer to the GlueRecPtr
} KQGestaltRec, *KQGestaltPtr;				// record (defined in Extension.h)

#define GET_KQ12_GLUE(gestaltResponse) (*((KQGestaltPtr)(gestaltResponse))->glueRecPtr)

//==============================================================================
// UTILITY ROUTINES IN KQGESTALT.C:

GluePtr GetKeyQuencerGlue(void);

// =============================================================================
#if GENERATINGPOWERPC
#pragma options align=reset
#endif
//==============================================================================

#endif  // kqgestalt.h

// =============================================================================
